文档章节

exception 异常捕获

Lee12
 Lee12
发布于 2017/09/07 15:18
字数 487
阅读 2
收藏 0
package exception;


import java.util.InputMismatchException;
import java.util.Scanner;

/**
 * 除法
 * 用户输入两个整数,计算商
 */
public class Devide {
    public static void main(String[]args){
        int a,b,c;//定义变量
        Scanner in=new Scanner(System.in);//实力话Scanner对象
       System.out.print("请输入两个整数:");//用户提示
        try {
            a=in.nextInt();//输入一个整数,存入变量a中
            b=in.nextInt();
            c=a/b;
            System.out.println("商为:"+c);
        } catch (InputMismatchException e) {
         //e.printStackTrace();//异常追踪 调试程序时显示追踪信息
            System.out.println("你只能输入数字!");
        }
        catch (ArithmeticException e){
           // e.printStackTrace();
            System.out.println("除数不能为0!");
        }
       // finally {
            System.out.println("程序结束!");//finally可以省略,在catch之后则就表示finally语句
       // }
    }
}
package exception;

import java.util.Scanner;

public class Devide1 {
    public static void main(String[]args){
        int a,b,c;//定义变量
        Scanner in=new Scanner(System.in);//实力话Scanner对象
        System.out.print("请输入两个数:");//用户提示
        try {
            a=in.nextInt();//输入一个整数,存入变量a中
            b=in.nextInt();
            try{
                c=a/b;
                System.out.println("商为:"+c);
        } catch (Exception e) {
            //e.printStackTrace();//异常追踪 调试程序时显示追踪信息
            System.out.println("除数不能为0!");
        }
        }
        catch (Exception e){
            // e.printStackTrace();
            System.out.println("你只能输入数字!");
        }
        System.out.println("程序结束!");//finally可以省略,在catch之后则就表示finally语句
    }
}
package exception;

import java.util.Scanner;

public class Devide2 {
    public static void main(String[]args){
        float a,b,c;//定义变量
        Scanner in=new Scanner(System.in);//实力话Scanner对象
        System.out.print("请输入两个数:");//用户提示
        try {
            a=in.nextFloat();//输入一个整数,存入变量a中
            b=in.nextFloat();
            try{
                c=a/b;
                if(String.valueOf(c).equals("Infinity")){
                    throw new ArithmeticException();//抛出异常
                }
                System.out.println("商为:"+c);
        } catch (Exception e) {
            System.out.println("除数不能为0!");
        }
        }
        catch (Exception e){
            System.out.println("你只能输入数字!");
        }
        System.out.println("程序结束!");//finally可以省略,在catch之后则就表示finally语句
    }
package exception;

public class Devide3 {
    private String name;
    private int age;
    public String getName(){
        return  name;
    }
    public void setName(String name){
        this.name=name;
    }
    public int getAge(){
        return  age;
    }
    //设置年龄
    public void setAge(int age)throws AgeException{
      if (age<0) throw new AgeException();
        this.age=age;
    }
    public static void main(String[]args){
        Devide3 s=new Devide3();
        try{
            s.setAge(-2);
        } catch (AgeException e) {
          // e.printStackTrace();
            System.out.println(e.getMessage());
        }
    }
}
自定义异常

package exception;

public class AgeException extends Exception {
    @Override
    public String getMessage() {
        return "年龄不能为负数";
    }
}

© 著作权归作者所有

共有 人打赏支持
Lee12
粉丝 4
博文 12
码字总数 11258
作品 0
昆明
前端工程师
java中的异常的捕获与抛出原则

在可能会出现exception的地方,要使用try-catch或者throws或者两者都要。我的判断依据是:如果对可能出现的exception不 想被外部(方法的调用者)知道,就在方法内部try-catch掉这个excep...

lzw_me
2014/04/30
0
0
python的异常处理,以及自定义异常

写出来的python程序不一定是完全正确的。即使所有逻辑都对了,但是用户在使用过程的不当,也会导致程序运行出错。 本文结构: 常见的异常类型 如何处理异常 如何自定义异常 1. 常见的异常大概...

hello_cjq
2016/10/20
0
0
【Java入门提高篇】Day17 Java异常处理(下)

  今天继续讲解java中的异常处理机制,主要介绍Exception家族的主要成员,自定义异常,以及异常处理的正确姿势。 Exception家族   一图胜千言,先来看一张图。   Exception这是一个父类...

雨淡云稠
05/10
0
0
Java中的Exception异常 自定义异常

public class Exception extends Throwable Exception 类及其子类是 Throwable 的一种形式,它指出了合理的应用程序想要捕获的条件。 public class RuntimeException extends Exception Runt...

Sandy_wu
2013/08/09
0
0
Struts2的异常配置

Struts2异常处理方式有两种;一种为全局异常映射,另外一种即为局部异常映射。 一、定义全局异常 在struts.xml文件中配置全局异常,通过<global-exception-mappings>标签下的<exception-mapp...

小伟_乌牛
01/10
0
0

没有更多内容

加载失败,请刷新页面

加载更多

创建第一个react项目

sudo npm i -g create-react-app@1.5.2 create-react-app react-app cd react-apprm -rf package-lock.jsonrm -rf node_modules #主要是为了避免报错npm installnpm start......

lilugirl
今天
3
0
在浏览器中进行深度学习:TensorFlow.js (八)生成对抗网络 (GAN)

Generative Adversarial Network 是深度学习中非常有趣的一种方法。GAN最早源自Ian Goodfellow的这篇论文。LeCun对GAN给出了极高的评价: “There are many interesting recent development...

naughty
今天
0
0
搬瓦工镜像站bwh1.net被DNS污染,国内打不开搬瓦工官网

今天下午(2018年10月17日),继搬瓦工主域名bandwagonhost.com被污染后,这个国内的镜像地址bwh1.net也被墙了。那么目前应该怎么访问搬瓦工官网呢? 消息来源:搬瓦工优惠网->搬瓦工镜像站b...

flyzy2005
今天
9
0
SpringBoot自动配置

本篇介绍下,如何通过springboot的自动配置,将公司项目内的依赖jar,不需要扫描路径,依赖jar的情况下,就能将jar内配置了@configuration注解的类,创建到IOC里面 介绍下开发环境 JDK版本1.8 spr...

贺小五
今天
5
0
命令行新建Maven多项目

参考地址 # DgroupId 可以理解为包名# DartifactId 可以理解为项目名mvn archetype:generate -DgroupId=cn.modfun -DartifactId=scaffold -DarchetypeArtifactId=maven-archetype-quickst......

阿白
今天
4
0

没有更多内容

加载失败,请刷新页面

加载更多

返回顶部
顶部